# -*- coding:Utf-8 -*-
import es, psyco, gamethread, playerlib, maplistlib, simplemenulib, dm_python, dm_player, dm_entities, dm_votemap, dm_usermenu, dm_language
from dm_votemap import dmVotemap
from dm_config import dmConfig
from dm_weapon import dmWeapon
from dm_spawns import dmSpawns
psyco.full()


def create():
    # main
    menu = simplemenulib.menu("_dm_python_administration_menu")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("admin main title", showpage = False)
    menu.addchoice("admin configuration option")
    menu.subsimplemenu("admin configuration option", "_dm_python_configuration_menu")
    menu.addchoice("admin items option")
    menu.subsimplemenu("admin items option", "_dm_python_items_menu")
    menu.addchoice("admin votemap option")
    menu.subsimplemenu("admin votemap option", "_dm_python_votemap_menu")
    menu.addchoice("admin restrict option")
    menu.subsimplemenu("admin restrict option", "_dm_python_restrict_menu")
    menu.addchoice("admin spawnpoint option")
    menu.addchoice("admin extension option")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = administration

    # configuration
    menu = simplemenulib.menu("_dm_python_configuration_menu")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("admin configuration title")
    menu.addchoice("configuration administration command", ("config imputbox admin", dmConfig.admin, "_dp_cvar_admin"))
    menu.subsimplemenu("configuration administration command", "_dm_python_configuration_menu")
    menu.addchoice("configuration deathmatch command", ("config imputbox command", dmConfig.command, "_dp_cvar_command"))
    menu.subsimplemenu("configuration deathmatch command", "_dm_python_configuration_menu")
    menu.addchoice("configuration randguns command", ("config imputbox randguns", dmConfig.randguns, "_dp_cvar_randguns"))
    menu.subsimplemenu("configuration randguns command", "_dm_python_configuration_menu")
    menu.addchoice("configuration deathmatch style", ("config imputbox style", dmConfig.style, "_dp_cvar_style"))
    menu.subsimplemenu("configuration deathmatch style", "_dm_python_configuration_menu")
    menu.addchoice("configuration menu timeout", ("config imputbox timeout", dmConfig.timeout, "_dp_cvar_timeout"))
    menu.subsimplemenu("configuration menu timeout", "_dm_python_configuration_menu")
    menu.addchoice("configuration respawn method", ("config imputbox method", dmConfig.plugin, "_dp_cvar_plugin"))
    menu.subsimplemenu("configuration respawn method", "_dm_python_configuration_menu")
    menu.addchoice("configuration respawn time", ("config imputbox respawn", dmConfig.respawn, "_dp_cvar_respawn"))
    menu.subsimplemenu("configuration respawn time", "_dm_python_configuration_menu")
    menu.addchoice("configuration respawn protection", ("config imputbox protection", dmConfig.protection, "_dp_cvar_protection"))
    menu.subsimplemenu("configuration respawn protection", "_dm_python_configuration_menu", 2)
    menu.addchoice("configuration respawn random", ("config imputbox random", dmConfig.random, "_dp_cvar_random"))
    menu.subsimplemenu("configuration respawn random", "_dm_python_configuration_menu", 2)
    menu.addchoice("configuration ragdoll dissolver", ("config imputbox dissolver", dmConfig.dissolver, "_dp_cvar_dissolver"))
    menu.subsimplemenu("configuration ragdoll dissolver", "_dm_python_configuration_menu", 2)
    menu.addchoice("configuration extended config", ("config imputbox extension", dmConfig.extension, "_dp_cvar_extension"))
    menu.subsimplemenu("configuration extended config", "_dm_python_configuration_menu", 2)
    menu.simplemenureturn("_dm_python_administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = value

    # items
    menu = simplemenulib.menu("_dm_python_items_menu")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("admin items title", showpage = False)
    menu.addchoice("items give assaultsuit", ("items imputbox assaultsuit", dmConfig.assaultsuit, "_dp_cvar_assaultsuit"))
    menu.subsimplemenu("items give assaultsuit", "_dm_python_items_menu")
    menu.addchoice("items give nightvision", ("items imputbox nightvision", dmConfig.nightvision, "_dp_cvar_nightvision"))
    menu.subsimplemenu("items give nightvision", "_dm_python_items_menu")
    menu.addchoice("items hegrenade max", ("items imputbox hegrenade", dmConfig.hegrenade, "_dp_cvar_hegrenade"))
    menu.subsimplemenu("items hegrenade max", "_dm_python_items_menu")
    menu.addchoice("items flashbang max", ("items imputbox flashbang", dmConfig.flashbang, "_dp_cvar_flashbang"))
    menu.subsimplemenu("items flashbang max", "_dm_python_items_menu")
    menu.addchoice("items smokegrenade max", ("items imputbox smokegrenade", dmConfig.smokegrenade, "_dp_cvar_smokegrenade"))
    menu.subsimplemenu("items smokegrenade max", "_dm_python_items_menu")
    menu.simplemenureturn("_dm_python_administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = value

    # votemap
    menu = simplemenulib.menu("_dm_python_votemap_menu")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("admin votemap title", showpage = False)
    menu.addchoice("votemap vote kills", ("votemap imputbox kills", dmConfig.kills, "_dp_cvar_kills"))
    menu.subsimplemenu("votemap vote kills", "_dm_python_votemap_menu")
    menu.addchoice("votemap vote time", ("votemap imputbox time", dmConfig.time, "_dp_cvar_time"))
    menu.subsimplemenu("votemap vote time", "_dm_python_votemap_menu")
    menu.addchoice("votemap max map", ("votemap imputbox maxmap", dmConfig.maxmap, "_dp_cvar_maxmap"))
    menu.subsimplemenu("votemap max map", "_dm_python_votemap_menu")
    menu.addchoice("votemap last maps", ("votemap imputbox lastmaps", dmConfig.lastmaps, "_dp_cvar_lastmaps"))
    menu.subsimplemenu("votemap last maps", "_dm_python_votemap_menu")
    menu.addchoice("votemap maplist management", None)
    menu.subsimplemenu("votemap maplist management", "_dm_python_maplist_management")
    menu.simplemenureturn("_dm_python_administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = value

    menu = simplemenulib.menu("_dm_python_maplist_management")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("maplist management title", showpage = False)
    menu.addchoice("maplist management list")
    menu.addchoice("maplist management append")
    menu.subsimplemenu("maplist management append", "_dm_python_maplist_management")
    menu.addchoice("maplist management remove")
    menu.addchoice("maplist management check")
    menu.subsimplemenu("maplist management check", "_dm_python_maplist_management")
    menu.simplemenureturn("_dm_python_votemap_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = maplist

    # restriction
    menu = simplemenulib.menu("_dm_python_restrict_menu")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("admin restrict title")
    for weaponName in dmWeapon.weaponlist: menu.addchoice("restrict weapon " + weaponName, weaponName, underline = True if weaponName in dmWeapon else False)
    menu.simplemenureturn("_dm_python_administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = restrict

    # spawnpoint
    menu = simplemenulib.menu("_dm_python_spawnpoint_menu")
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    menu.title("admin spawnpoint title")
    menu.addchoice("spawnpoint noclip status")
    menu.addchoice("spawnpoint add position")
    menu.addchoice("spawnpoint move current")
    menu.subsimplemenu("spawnpoint move current", "_dm_python_spawnpoint_menu")
    menu.addchoice("spawnpoint move next")
    menu.addchoice("spawnpoint move back")
    menu.addchoice("spawnpoint del current")
    menu.addchoice("spawnpoint restore origins")
    menu.addchoice("spawnpoint show spawnpoints")
    menu.subsimplemenu("spawnpoint show spawnpoints", "_dm_python_spawnpoint_menu", 2)
    menu.addchoice("spawnpoint show origins")
    menu.subsimplemenu("spawnpoint show origins", "_dm_python_spawnpoint_menu", 2)
    menu.addchoice("spawnpoint show customs")
    menu.subsimplemenu("spawnpoint show customs", "_dm_python_spawnpoint_menu", 2)
    menu.addchoice("spawnpoint remove spawnpoints")
    menu.addchoice("spawnpoint remove origins")
    menu.addchoice("spawnpoint remove customs")
    menu.simplemenureturn("_dm_python_administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = spawnpoint

def administration(userid, index, choice, value, name, page):
    if index == 5:
        if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            simplemenulib.send(userid, name)
            es.tell(userid, "#multi", dm_language.message(userid, "admin alive message"))
        else: spawnpointUpdate(userid, lastspawn = True)

    elif index == 6:
        if int(dmConfig.extension): simplemenulib.send(userid, "_dm_python_extension_menu")
        else:
            simplemenulib.send(userid, name)
            es.tell(userid, "#multi", dm_language.message(userid, "admin extension disable"))

def administrationUpdate(userid):
    menu = simplemenulib.find("_dm_python_administration_menu")
    if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"): menu.modchoice("admin spawnpoint option", "admin spawnpoint option", underline = False)
    else: menu.modchoice("admin spawnpoint option", "admin spawnpoint option")
    if int(dmConfig.extension): menu.modchoice("admin extension option", "admin extension option", underline = True)
    else: menu.modchoice("admin extension option", "admin extension option", underline = False)
    if menu.isqueued(userid, 1): menu.update(userid)
    else: menu.send(userid)

""" configuration, equipment and votemap """
def value(userid, index, choice, value, name, page):
    if value is not None:
        boxmsg, value, command = value
        es.tell(userid, "#multi", dm_language.message(userid, "escmenu imputbox message"))
        es.escinputbox(20, userid, dm_language.message(userid, boxmsg), dm_language.message(userid, "escmenu imputbox currentvalue", {"value" : value}), command)

""" maplist """
def maplist(userid, index, choice, value, name, page):
    if index == 1:
        menu = simplemenulib.list("_dm_python_maplist_show_" + str(userid))
        menu.loadlang("cfg/dm_python/language/administration_menu.ini")
        menu.simplemenureturn("_dm_python_maplist_management")
        menu.addlist("_dm_python_list_menu")
        menu.title("management list title", showpage = len(dm_votemap.maplist) > 8)
        for mapname in dm_votemap.maplist: menu.additem("management list mapname", options = {"$mapname" : mapname})
        menu.blocklist = mapshow
        menu.display(userid)

    elif index == 2: es.escinputbox(20, userid, dm_language.message(userid, "escmenu imputbox addmap"), dm_language.message(userid, "escmenu imputbox addexample"), "_dp_add_mapname")
    elif index == 3: maprefresh(userid)
    elif index == 4:
        es.tell(userid, "#multi", dm_language.message(userid, "deathmatch map check"))
        dm_votemap.maplist.setlist(dm_votemap.maplist.getlist())
        dmVotemap.read()

def mapshow(userid, index, choice, value, name, page):
    simplemenulib.find(name).display(userid, page)

def maprefresh(userid, page = 1):
    menu = simplemenulib.menu("_dm_python_maplist_remove_" + str(userid))
    menu.loadlang("cfg/dm_python/language/administration_menu.ini")
    for mapname in dm_votemap.maplist: menu.addchoice("management remove mapname", mapname, {"$mapname" : mapname})
    menu.title("management remove title", showpage = len(dm_votemap.maplist) > 8)
    menu.simplemenureturn("_dm_python_maplist_management")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = mapremove
    menu.send(userid, page if menu.pageexists(page) else page - 1)

def mapremove(userid, index, choice, value, name, page):
    dm_votemap.maplist - value
    maprefresh(userid, page)
    dmVotemap.read()

""" restriction """
def restrict(userid, index, choice, value, name, page):
    remove = False
    menu = simplemenulib.find(name)
    if value in dmWeapon:
        remove = True
        dmWeapon - value
        menu.modchoice(choice, choice, value, underline = False)
    else:
        dmWeapon + value
        menu.modchoice(choice, choice, value, underline = True)

    menu.send(userid, page)
    dmWeapon.save()
    dmWeapon.read()
    dm_usermenu.create()

    if remove:
        weapon, userids = "weapon_" + value, []
        handles = map(lambda player: handles.append(player.player.handle), dm_player.dmPlayer.values())
        for index in es.createentityindexlist(weapon):
            handle = es.getindexprop(index, "CBaseEntity.m_hOwnerEntity")
            if handle in handles:
                if not usid in userids: userids.append(usid)

        for usid in userids:
            player = dm_player.player(userid).player
            player.refreshAttributes()
            if player.weapon == weapon: es.cexec(usid, "lastinv")
            es.tell(usid, "#multi", dm_language.message(usid, "deathmatch restricted weapon", {"weapon" : value}))
        dm_entities.removeEntity(weapon, userid)


""" spawnpoints """
def spawnpoint(userid, index, choice, value, name, page):
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        if page == 1:
            if index == 1:
                menu = simplemenulib.find(name)
                player = dm_player.player(userid).player
                if bool(player.noclip):
                    player.noclip = False
                    menu.modchoice(choice, choice, underline = False)
                else:
                    player.noclip = True
                    menu.modchoice(choice, choice, underline = True)
                menu.send(userid)

            elif index == 2:
                dmSpawns.add(userid)
                player = dm_player.player(userid)
                player.indexspawn += 1
                spawnpointUpdate(userid)

            elif index == 3: dmSpawns.set(userid)
            elif index == 4:
                team = es.getplayerteam(userid)
                spawnlist = dmSpawns.terrorist if team == 2 else dmSpawns.counterterrorist
                spawncount = len(spawnlist)

                if spawncount:
                    player = dm_player.player(userid)
                    if player.indexspawn + 1 < spawncount: player.indexspawn += 1
                    else: player.indexspawn = 0
                    dmSpawns.set(userid)
                spawnpointUpdate(userid)

            elif index == 5:
                team = es.getplayerteam(userid)
                spawnlist = dmSpawns.terrorist if team == 2 else dmSpawns.counterterrorist
                spawncount = len(spawnlist)
                if spawncount:

                    player = dm_player.player(userid)
                    if player.indexspawn > 0: player.indexspawn -= 1
                    else: player.indexspawn = spawncount - 1 if spawncount else 0
                    dmSpawns.set(userid)
                spawnpointUpdate(userid)

            elif index == 6:
                team = es.getplayerteam(userid)
                spawnlist = dmSpawns.terrorist if team == 2 else dmSpawns.counterterrorist
                player = dm_player.player(userid)

                if player.indexspawn > -1:
                    dmSpawns.sub(userid)
                    player.indexspawn -= 1
                if player.indexspawn < 0:
                    spawncount = len(spawnlist)
                    player.indexspawn = spawncount - 1 if spawncount else -1
                spawnpointUpdate(userid)
            elif index == 7:
                dmSpawns.restore(userid)
                spawnpointUpdate(userid, True)

        elif page == 2:
            if index == 1: dmSpawns.show(userid)
            elif index == 2: dmSpawns.show(userid, "origin")
            elif index == 3: dmSpawns.show(userid, "custom")

            elif index == 4:
                dmSpawns.delete(userid)
                spawnpointUpdate(userid, True, page = 2)
            elif index == 5:
                dmSpawns.delete(userid, "origin")
                spawnpointUpdate(userid, True, page = 2)
            elif index == 6:
                dmSpawns.delete(userid, "custom")
                spawnpointUpdate(userid, True, page = 2)

def spawnpointUpdate(userid, lastspawn = False, update = False, page = 1):
    spawnlist = dmSpawns.getSpawnsList(userid)
    user = dm_player.player(userid)
    isdead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
    if lastspawn: user.indexspawn = len(spawnlist) - 1
    menu = simplemenulib.find("_dm_python_spawnpoint_menu")
    menu.title("admin spawnpoint title", {"$number" : user.indexspawn + 1}, False)

    if bool(playerlib.getPlayer(userid).noclip) and not isdead: menu.modchoice("spawnpoint noclip status", "spawnpoint noclip status", underline = True)
    else: menu.modchoice("spawnpoint noclip status", "spawnpoint noclip status", underline = False)
    if not isdead: menu.modchoice("spawnpoint add position", "spawnpoint add position", underline = True)
    else: menu.modchoice("spawnpoint add position", "spawnpoint add position", underline = False)

    if spawnlist and not isdead:
        menu.modchoice("spawnpoint move current", "spawnpoint move current", underline = True)
        menu.modchoice("spawnpoint move next", "spawnpoint move next", underline = True)
        menu.modchoice("spawnpoint move back", "spawnpoint move back", underline = True)
        menu.modchoice("spawnpoint del current", "spawnpoint del current", underline = True)

    else:
        menu.modchoice("spawnpoint move current", "spawnpoint move current", underline = False)
        menu.modchoice("spawnpoint move next", "spawnpoint move next", underline = False)
        menu.modchoice("spawnpoint move back", "spawnpoint move back", underline = False)
        menu.modchoice("spawnpoint del current", "spawnpoint del current", underline = False)

    if spawnlist:
        menu.modchoice("spawnpoint show spawnpoints", "spawnpoint show spawnpoints", underline = True)
        menu.modchoice("spawnpoint remove spawnpoints", "spawnpoint remove spawnpoints", underline = True)
    else:
        menu.modchoice("spawnpoint show spawnpoints", "spawnpoint show spawnpoints", underline = False)
        menu.modchoice("spawnpoint remove spawnpoints", "spawnpoint remove spawnpoints", underline = False)

    if dmSpawns.getSpawnsList(userid, "origin"):
        menu.modchoice("spawnpoint show origins", "spawnpoint show origins", underline = True)
        menu.modchoice("spawnpoint remove origins", "spawnpoint remove origins", underline = True)
    else:
        menu.modchoice("spawnpoint show origins", "spawnpoint show origins", underline = False)
        menu.modchoice("spawnpoint remove origins", "spawnpoint remove origins", underline = False)

    if dmSpawns.getSpawnsList(userid, "custom"):
        menu.modchoice("spawnpoint show customs", "spawnpoint show customs", underline = True)
        menu.modchoice("spawnpoint remove customs", "spawnpoint remove customs", underline = True)
    else:
        menu.modchoice("spawnpoint show customs", "spawnpoint show customs", underline = False)
        menu.modchoice("spawnpoint remove customs", "spawnpoint remove customs", underline = False)

    if update: menu.update(userid, page)
    else: menu.send(userid, page)
